Lucene++ - a full-featured, c++ search engine
API Documentation

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Member Functions | Protected Attributes
Lucene::LongComparator Class Reference

Parses field's values as long (using FieldCache#getLongs and sorts by ascending value. More...

`#include <FieldComparator.h>`

Inheritance diagram for Lucene::LongComparator:

## Public Member Functions

| LongComparator (int32_t numHits, const String &field, const ParserPtr &parser)
virtual | ~LongComparator ()
virtual String | getClassName ()
boost::shared_ptr< LongComparator > | shared_from_this ()
virtual int32_t | compare (int32_t slot1, int32_t slot2)
| Compare hit at slot1 with hit at slot2. More...
virtual int32_t | compareBottom (int32_t doc)
| Compare the bottom of the queue with doc. This will only invoked after setBottom has been called. This should return the same result as compare(int,int)} as if bottom were slot1 and the new document were slot 2. More...
virtual void | setNextReader (const IndexReaderPtr &reader, int32_t docBase)
| Set a new Reader. All doc correspond to the current Reader. More...
Public Member Functions inherited from Lucene::NumericComparator< int64_t >
| NumericComparator (int32_t numHits, const String &field=EmptyString)
virtual | ~NumericComparator ()
virtual void | copy (int32_t slot, int32_t doc)
| This method is called when a new hit is competitive. You should copy any state associated with this document that will be required for future comparisons, into the specified slot. More...
virtual void | setBottom (int32_t slot)
| Set the bottom slot, ie the "weakest" (sorted last) entry in the queue. When compareBottom is called, you should compare against this slot. This will always be called before compareBottom. More...
virtual ComparableValue | value (int32_t slot)
| Return the actual value in the slot. More...
Public Member Functions inherited from Lucene::FieldComparator
virtual | ~FieldComparator ()
boost::shared_ptr< FieldComparator > | shared_from_this ()
virtual void | setScorer (const ScorerPtr &scorer)
| Sets the Scorer to use in case a document's score is needed. More...
Public Member Functions inherited from Lucene::LuceneObject
virtual | ~LuceneObject ()
virtual void | initialize ()
| Called directly after instantiation to create objects that depend on this object being fully constructed. More...
virtual LuceneObjectPtr | clone (const LuceneObjectPtr &other=LuceneObjectPtr())
| Return clone of this object. More...
virtual int32_t | hashCode ()
| Return hash code for this object. More...
virtual bool | equals (const LuceneObjectPtr &other)
| Return whether two objects are equal. More...
virtual int32_t | compareTo (const LuceneObjectPtr &other)
| Compare two objects. More...
virtual String | toString ()
| Returns a string representation of the object. More...
Public Member Functions inherited from Lucene::LuceneSync
virtual | ~LuceneSync ()
virtual SynchronizePtr | getSync ()
| Return this object synchronize lock. More...
virtual LuceneSignalPtr | getSignal ()
| Return this object signal. More...
virtual void | lock (int32_t timeout=0)
| Lock this object using an optional timeout. More...
virtual void | unlock ()
| Unlock this object. More...
virtual bool | holdsLock ()
| Returns true if this object is currently locked by current thread. More...
virtual void | wait (int32_t timeout=0)
| Wait for signal using an optional timeout. More...
virtual void | notifyAll ()
| Notify all threads waiting for signal. More...

## Static Public Member Functions

static String | _getClassName ()
Static Public Member Functions inherited from Lucene::FieldComparator
static String | _getClassName ()

## Protected Attributes

LongParserPtr | parser
Protected Attributes inherited from Lucene::NumericComparator< int64_t >
Collection< int64_t > | values
Collection< int64_t > | currentReaderValues
String | field
int64_t | bottom
Protected Attributes inherited from Lucene::LuceneSync
SynchronizePtr | objectLock
LuceneSignalPtr | objectSignal

## Additional Inherited Members

Protected Member Functions inherited from Lucene::LuceneObject
| LuceneObject ()

## Detailed Description

Parses field's values as long (using FieldCache#getLongs and sorts by ascending value.

## Constructor & Destructor Documentation

Lucene::LongComparator::LongComparator | ( | int32_t | numHits,
|  | const String & | field,
|  | const ParserPtr & | parser
| ) |  |

virtual Lucene::LongComparator::~LongComparator | ( |  | ) |

virtual

## Member Function Documentation

static String Lucene::LongComparator::_getClassName | ( |  | ) |

inline static

virtual int32_t Lucene::LongComparator::compare | ( | int32_t | slot1,
|  | int32_t | slot2
| ) |  |

virtual

Compare hit at slot1 with hit at slot2.

Parameters

  slot1 | first slot to compare
  slot2 | second slot to compare

Returns
  any N < 0 if slot2's value is sorted after slot1, any N > 0 if the slot2's value is sorted before slot1 and 0 if they are equal

Reimplemented from Lucene::NumericComparator< int64_t >.

virtual int32_t Lucene::LongComparator::compareBottom | ( | int32_t | doc | ) |

virtual

Compare the bottom of the queue with doc. This will only invoked after setBottom has been called. This should return the same result as compare(int,int)} as if bottom were slot1 and the new document were slot 2.

For a search that hits many results, this method will be the hotspot (invoked by far the most frequently).

Parameters

  doc | that was hit

Returns
  any N < 0 if the doc's value is sorted after the bottom entry (not competitive), any N > 0 if the doc's value is sorted before the bottom entry and 0 if they are equal.

Reimplemented from Lucene::NumericComparator< int64_t >.

virtual String Lucene::LongComparator::getClassName | ( |  | ) |

inline virtual

Reimplemented from Lucene::FieldComparator.

virtual void Lucene::LongComparator::setNextReader | ( | const IndexReaderPtr & | reader,
|  | int32_t | docBase
| ) |  |

virtual

Set a new Reader. All doc correspond to the current Reader.

Parameters

  reader | current reader
  docBase | docBase of this reader

Implements Lucene::FieldComparator.

boost::shared_ptr< LongComparator > Lucene::LongComparator::shared_from_this | ( |  | ) |

inline

## Field Documentation

LongParserPtr Lucene::LongComparator::parser

protected

The documentation for this class was generated from the following file:

- FieldComparator.h

clucene.sourceforge.net